from urllib2 import urlopen
import httplib
import urlparse
from Components.MenuList import MenuList
from Components.Label import Label

from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.ActionMap import NumberActionMap
from Components.Input import Input
from Components.Pixmap import Pixmap
from Components.FileList import FileList
from Screens.ChoiceBox import ChoiceBox
from Plugins.Plugin import PluginDescriptor
from Components.ActionMap import ActionMap
from Screens.InputBox import InputBox

#from twisted.web.client import getPage, downloadPage
#from Plugins.Extensions.VlcPlayer.VlcServerConfig import vlcServerConfig
import os
from Screens.InfoBar import MoviePlayer
from enigma import eServiceReference
from enigma import eServiceCenter

from Components.Task import Task, Job, job_manager as JobManager, Condition
from Screens.TaskView import JobView
from Components.Button import Button

from enigma import eServiceReference
from enigma import eServiceCenter
from Screens.InfoBar import MoviePlayer

from Components.config import config
from Skins import *
############################################################
from enigma import ePicLoad, eTimer, getDesktop

from Screens.Screen import Screen
from Tools.Directories import resolveFilename, pathExists, fileExists, SCOPE_MEDIA
from Plugins.Plugin import PluginDescriptor

from Components.Pixmap import Pixmap, MovingPixmap
from Components.ActionMap import ActionMap, NumberActionMap
from Components.Sources.StaticText import StaticText
from Components.FileList import FileList
from Components.AVSwitch import AVSwitch
from Components.Sources.List import List
from Components.ConfigList import ConfigList, ConfigListScreen

from Components.config import config, ConfigSubsection, ConfigInteger, ConfigSelection, ConfigText, ConfigEnableDisable, KEY_LEFT, KEY_RIGHT, KEY_0, getConfigListEntry
from Components.Task import Task, Job, job_manager as JobManager, Condition
from Screens.TaskView import JobView

from Screens.Console import Console
from enigma import eConsoleAppContainer

##################
from twisted.web.client import getPage, downloadPage

##############################################################
#                                                            #
#   Coded by pcd@i-have-a-dreambox, Dec 2010                 #
#                                                            #
##############################################################



class Getvid(Screen):


    def __init__(self, session, name, url, desc):
		self.skin = SkinC.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
		self["key_red"] = Button(_("Exit"))
		self["key_green"] = Button(_("Download"))
		self["key_yellow"] = Button(_("Play"))
		self["key_blue"] = Button(_("Stop Download"))
                self["setupActions"] = ActionMap(["SetupActions", "ColorActions", "TimerEditActions"],
		{
			"red": self.close,
			"green": self.okClicked,
			"yellow": self.play,
			"blue": self.stopDL,
			"cancel": self.cancel,
			"ok": self.okClicked,
		}, -2)
                self.icount = 0
                self.bLast = 0
                print "Getvid : name =", name
                
                cachefold = config.plugins.webmedia.cachefold.value
                self.svfile = cachefold + "/" + name + ".mpg"
                
                txt =name + "\n\n\\n" + desc
                self["info"].setText(txt)
                
                self.updateTimer = eTimer()
	    	self.updateTimer.callback.append(self.updateStatus)
		self.updateTimer.start(2000)
		self.updateStatus()
                
                self.name = name
                self.url = url
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
#                self.onLayoutFinish.append(self.openTest)

    def openTest(self):
        vid = self.name
        infotxt = "Video selected :-\n\n\n" + vid 
        self["info"].setText(infotxt)  
           
    def play(self):
        pvid = Playvid(self.session,self.name,self.url)
#        self.session.open(Playvid,self.name,self.url)
        pvid.openTest()
        self.close()


    def play2(self):

#                os.system("sleep 2")
                url = self.url
                name = self.name
                self.session.nav.stopService()
                sref = eServiceReference(4097,0,url)
                sref.setName(name)
	        self.session.nav.playService(sref)
	        Screen.close(self)



    def okClicked(self):
           cmd = "rm " + self.svfile
           os.system(cmd)
           self.icount = 1
           JobManager.AddJob(downloadJob(self, "wget -c '" + self.url + "' -O '" + self.svfile + "'", self.svfile, 'Title 1'))
#           self.LastJobView()


    def updateStatus(self):
           if not os.path.exists(self.svfile) :
                   return
           else:
               if self.icount == 0:
                   return
               else:    
                   b1 = os.path.getsize(self.svfile)
                   b = b1/1000
                   print "self.bLast, b =", self.bLast, b 
                   if b == self.bLast:
                          infotxt = "Download Complete...." + str(b)
                          self["info"].setText(infotxt)
                          return                          
                   self.bLast = b
                   infotxt = "Downloading...." + str(b) + " kb"
                   print "infotxt = ", infotxt   
                   self["info"].setText(infotxt)

    def LastJobView(self):
		currentjob = None
		for job in JobManager.getPendingJobs():
			currentjob = job

		if currentjob is not None:
			self.session.open(JobView, currentjob)

                
    def cancel(self):
	        self.session.nav.playService(self.srefOld)
                self.close()

    def stopDL(self):
                cmd = "killall -9 wget &"
                os.system(cmd)
    
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)	

class Playvid(Screen):

    def __init__(self, session, name, url):
		self.skin = SkinB.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
		self["setupActions"] = ActionMap(["SetupActions", "ColorActions", "TimerEditActions"],
		{
			
			"cancel": self.cancel,
			"ok": self.okClicked,
		}, -2)
                self.icount = 0
#                self.ict = 0
                print "Playvid : name =", name
                print "Playvid : url =", url
                
#                self.cachefold = "/media/hdd/movie"

                self.name = name
                self.url = url
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
                self.onLayoutFinish.append(self.openTest)

    def openTest2(self):
                self.session.open(Showvid, self.name, self.url)

    def openTest(self):                
                url = self.url
                name = self.name
                self.session.nav.stopService()
                sref = eServiceReference(4097,0,url)
                sref.setName(name)
#	        self.session.nav.playService(sref)
                print "sref =", sref.toString()
                self.session.open(MoviePlayer, sref)
#                self.session.nav.playService(sref)
#                self.Screen.close()
                
                 
           

    def cancel(self):
                self.close()

    def okClicked(self):            
                return

    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)	

class Showvid(Screen):

    skin = """
		<screen position="center,center" size="0, 0" title=" " flags="wfNoBorder"  >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="345,280" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="100,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />

		</screen>"""

    def __init__(self, session, name, url):
		self.skin = Showvid.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
		self["setupActions"] = ActionMap(["SetupActions", "ColorActions", "TimerEditActions"],
		{
			
			"cancel": self.cancel,
			"ok": self.okClicked,
		}, -2)
                self.icount = 0
#                self.ict = 0
                print "Playvid : name =", name
                print "Playvid : url =", url
                
#                self.cachefold = "/media/hdd/movie"

                self.name = name
                self.url = url
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
                self.onLayoutFinish.append(self.openTest)

    def openTest(self):
          if self.url != " ": 
                url = self.url
                name = self.name
                self.session.nav.stopService()
                sref = eServiceReference(4097,0,url)
                sref.setName(name)
#	        self.session.nav.playService(sref)
                print "sref =", sref.toString()
#                self.session.open(MoviePlayer, sref)
                self.session.nav.playService(sref)
#                self.Screen.close()


          else:
                return
           

    def cancel(self):
	        self.session.nav.playService(self.srefOld)
                self.close()

    def okClicked(self):            
                return

    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)	



class downloadJob(Job):
	def __init__(self, toolbox, cmdline, filename, filetitle):
		Job.__init__(self, _("Saving Video"))
		self.toolbox = toolbox
		self.retrycount = 0
		
                downloadTask(self, cmdline, filename, filetitle)

	def retry(self):
		assert self.status == self.FAILED
		self.retrycount += 1
		self.restart()
	
class downloadTask(Task):
	ERROR_CORRUPT_FILE, ERROR_RTMP_ReadPacket, ERROR_SEGFAULT, ERROR_SERVER, ERROR_UNKNOWN = range(5)
	def __init__(self, job, cmdline, filename, filetitle):
		Task.__init__(self, job, filetitle)
#		self.postconditions.append(downloadTaskPostcondition())
		self.setCmdline(cmdline)
		self.filename = filename
		self.toolbox = job.toolbox
		self.error = None
		self.lasterrormsg = None
		
	def processOutput(self, data):
		try:
			if data.endswith('%)'):
				startpos = data.rfind("sec (")+5
				if startpos and startpos != -1:
					self.progress = int(float(data[startpos:-4]))
			elif data.find('%') != -1:
				tmpvalue = data[:data.find("%")]
				tmpvalue = tmpvalue[tmpvalue.rfind(" "):].strip()
				tmpvalue = tmpvalue[tmpvalue.rfind("(")+1:].strip()
				self.progress = int(float(tmpvalue))
			else:
				Task.processOutput(self, data)
		except Exception, errormsg:
			print "Error processOutput: " + str(errormsg)
			Task.processOutput(self, data)

	def processOutputLine(self, line):
			self.error = self.ERROR_SERVER
			
	def afterRun(self):
		pass

class downloadTaskPostcondition(Condition):
	RECOVERABLE = True
	def check(self, task):
		if task.returncode == 0 or task.error is None:
			return True
		else:
			return False

	def getErrorMessage(self, task):
		return {
			task.ERROR_CORRUPT_FILE: _("Video Download Failed!Corrupted Download File:%s" % task.lasterrormsg),
			task.ERROR_RTMP_ReadPacket: _("Video Download Failed!Could not read RTMP-Packet:%s" % task.lasterrormsg),
			task.ERROR_SEGFAULT: _("Video Download Failed!Segmentation fault:%s" % task.lasterrormsg),
#			task.ERROR_SERVER: _("Download Failed!-Server error:%s" % task.lasterrormsg),
			task.ERROR_SERVER: _("Download Failed!-Server error:"),
			task.ERROR_UNKNOWN: _("Video Download Failed!Unknown Error:%s" % task.lasterrormsg)
		}[task.error]

#######################
def getScale():
	return AVSwitch().getFramebufferScale()



T_INDEX = 0
T_FRAME_POS = 1
T_PAGE = 2
T_NAME = 3
T_FULL = 4

class Pic_Thumb(Screen):
	def __init__(self, session, mediadir, names, picurls, urls, indic):
#                self.picdir = mediadir + "/images/"
#                self.tempdir = mediadir + "/tmp/"
                self.names = names
                self.picurls = picurls
                self.urls = urls
                self.indic = indic
                
                print " mediadir =", mediadir
	        print " names[1] =", names[1]
	        print " picurls[1] =",picurls[1]
	        print " urls[1] =", urls[1]
	        print " indic =", indic
                
                currDir = mediadir
 
		self.filelist = FileList(currDir, matchingPattern = "(?i)^.*\.(jpeg|jpg|jpe|png|bmp|gif)")
		self["filelist"] = self.filelist
#		self["filelist"].onSelectionChanged.append(self.selectionChanged)

#		self.ThumbTimer = eTimer()
#		self.ThumbTimer.callback.append(self.showThumb)

#		self.picload = ePicLoad()
#		self.picload.PictureData.get().append(self.showPic)

#		self.onLayoutFinish.append(self.setConf)

#                self.session.openWithCallback(self.callbackView, Pic_Thumb, self.filelist.getFileList(), self.filelist.getSelectionIndex(), self.filelist.getCurrentDirectory())
                piclist = self.filelist.getFileList()
                lastindex = self.filelist.getSelectionIndex()
                path = self.filelist.getCurrentDirectory()
                
                print " self.filelist =", self.filelist
	        print " piclist =", piclist
	        print " lastindex =", lastindex
	        print " path =", path
                

###############################
		self.textcolor = config.pic.textcolor.value
		self.color = config.pic.bgcolor.value
		textsize = 20
		self.spaceX = 35
		self.picX = 190
		self.spaceY = 30
		self.picY = 200

		size_w = getDesktop(0).size().width()
		size_h = getDesktop(0).size().height()
		self.thumbsX = size_w / (self.spaceX + self.picX) # thumbnails in X
		self.thumbsY = size_h / (self.spaceY + self.picY) # thumbnails in Y
		self.thumbsC = self.thumbsX * self.thumbsY # all thumbnails

		self.positionlist = []
		skincontent = ""

		posX = -1
		for x in range(self.thumbsC):
			posY = x / self.thumbsX
			posX += 1
			if posX >= self.thumbsX:
				posX = 0

			absX = self.spaceX + (posX*(self.spaceX + self.picX))
			absY = self.spaceY + (posY*(self.spaceY + self.picY))
			self.positionlist.append((absX, absY))
#			skincontent += "<widget source=\"label" + str(x) + "\" render=\"Label\" position=\"" + str(absX+5) + "," + str(absY+self.picY-textsize) + "\" size=\"" + str(self.picX - 10) + ","  + str(textsize) + "\" font=\"Regular;14\" zPosition=\"2\" transparent=\"1\" noWrap=\"1\" foregroundColor=\"" + self.textcolor + "\" />"
			skincontent += "<widget source=\"label" + str(x) + "\" render=\"Label\" position=\"" + str(absX+5) + "," + str(absY+self.picY-textsize) + "\" size=\"" + str(self.picX - 10) + ","  + str(textsize) + "\" font=\"Regular;18\" zPosition=\"2\" transparent=\"1\" noWrap=\"1\" foregroundColor=\"" + self.textcolor + "\" />"
#                        skincontent += "<widget source=\"label" + str(x) + "\" render=\"Label\" position=\"" + str(absX+2) + "," + str(absY+self.picY-textsize-10) + "\" size=\"" + str(self.picX - 10) + ","  + str((textsize*3)+0) + "\" halign=\"center\" font=\"Regular;" + str(textsize) + "\" zPosition=\"4\" transparent=\"1\" foregroundColor=\"" + self.textcolor + "\" />"


			skincontent += "<widget name=\"thumb" + str(x) + "\" position=\"" + str(absX+5)+ "," + str(absY+5) + "\" size=\"" + str(self.picX -10) + "," + str(self.picY - (textsize*2)) + "\" zPosition=\"2\" transparent=\"1\" alphatest=\"on\" />"
                        print "self.positionlist =", self.positionlist
                        print "skincontent =", skincontent
                        
		# Screen, backgroundlabel and MovingPixmap
		self.skin = "<screen position=\"0,0\" size=\"" + str(size_w) + "," + str(size_h) + "\" flags=\"wfNoBorder\" > \
			<eLabel position=\"0,0\" zPosition=\"0\" size=\""+ str(size_w) + "," + str(size_h) + "\" backgroundColor=\"" + self.color + "\" /><widget name=\"frame\" position=\"35,30\" size=\"190,200\" pixmap=\"pic_frame.png\" zPosition=\"1\" alphatest=\"on\" />"  + skincontent + "</screen>"

                print " self.skin =", self.skin
                
		Screen.__init__(self, session)

		self["actions"] = ActionMap(["OkCancelActions", "ColorActions", "DirectionActions", "MovieSelectionActions"],
		{
			"cancel": self.Exit,
			"ok": self.KeyOk,
			"left": self.key_left,
			"right": self.key_right,
			"up": self.key_up,
			"down": self.key_down,
			"showEventInfo": self.StartExif,
		}, -1)

		self["frame"] = MovingPixmap()
		for x in range(self.thumbsC):
			self["label"+str(x)] = StaticText()
			self["thumb"+str(x)] = Pixmap()
			

		self.Thumbnaillist = []
		self.filelist = []
		self.currPage = -1
		self.dirlistcount = 0
		self.path = path

		index = 0
		framePos = 0
		Page = 0
		
		for x in piclist:
			if x[0][1] == False:
                                self.filelist.append((index, framePos, Page, x[0][0],  path + x[0][0]))
				index += 1
				framePos += 1
				if framePos > (self.thumbsC -1):
					framePos = 0
					Page += 1
				
			else:
				self.dirlistcount += 1


		self.maxentry = len(self.filelist)-1
		self.index = lastindex - self.dirlistcount
		if self.index < 0:
			self.index = 0

		self.picload = ePicLoad()
		self.picload.PictureData.get().append(self.showPic)

		self.onLayoutFinish.append(self.setPicloadConf)

		self.ThumbTimer = eTimer()
		self.ThumbTimer.callback.append(self.showPic)
		

	def setPicloadConf(self):
		
                sc = getScale()
		self.picload.setPara([self["thumb0"].instance.size().width(), self["thumb0"].instance.size().height(), sc[0], sc[1], config.pic.cache.value, int(config.pic.resize.value), self.color])
		self.paintFrame()


	def paintFrame(self):
		if self.maxentry < self.index or self.index < 0:
			return

		pos = self.positionlist[self.filelist[self.index][T_FRAME_POS]]
		self["frame"].moveTo( pos[0], pos[1], 1)
		self["frame"].startMoving()

		if self.currPage != self.filelist[self.index][T_PAGE]:
			self.currPage = self.filelist[self.index][T_PAGE]
			self.newPage()

	def newPage(self):
		self.Thumbnaillist = []
		#clear Labels and Thumbnail
		for x in range(self.thumbsC):
			self["label"+str(x)].setText("")
			self["thumb"+str(x)].hide()
		#paint Labels and fill Thumbnail-List
                for x in self.filelist:
			if x[T_PAGE] == self.currPage:
				text = "(" + str(x[T_INDEX]+1) + ") " + x[T_NAME]
                                name = x[T_NAME][:-4]
                                self["label"+str(x[T_FRAME_POS])].setText(name)

				self.Thumbnaillist.append([0, x[T_FRAME_POS], x[T_FULL]])
        


		#paint Thumbnail start
		self.showPic()

	def showPic(self, picInfo=""):
                for x in range(len(self.Thumbnaillist)):
			if self.Thumbnaillist[x][0] == 0:
				if self.picload.getThumbnail(self.Thumbnaillist[x][2]) == 1: #zu tun probier noch mal
					self.ThumbTimer.start(500, True)
				else:
					self.Thumbnaillist[x][0] = 1
				break
			elif self.Thumbnaillist[x][0] == 1:
				self.Thumbnaillist[x][0] = 2
				ptr = self.picload.getData()
				if ptr != None:
					self["thumb" + str(self.Thumbnaillist[x][1])].instance.setPixmap(ptr.__deref__())
					self["thumb" + str(self.Thumbnaillist[x][1])].show()

	def key_left(self):
		self.index -= 1
		if self.index < 0:
			self.index = self.maxentry
		self.paintFrame()

	def key_right(self):
		self.index += 1
		if self.index > self.maxentry:
			self.index = 0
		self.paintFrame()

	def key_up(self):
		self.index -= self.thumbsX
		if self.index < 0:
			self.index =self.maxentry
		self.paintFrame()

	def key_down(self):
		self.index += self.thumbsX
		if self.index > self.maxentry:
			self.index = 0
		self.paintFrame()

	def StartExif(self):
		if self.maxentry < 0:
			return
		self.session.open(Pic_Exif, self.picload.getInfo(self.filelist[self.index][T_FULL]))

	def KeyOk(self):
		if self.maxentry < 0:
			return
                self.old_index = self.index
                name = self.filelist[self.index][T_NAME]
                ix = len(self.names) - 1 
                i =0 
 
                while i < ix:
                       fullnm = self.names[i] + ".jpg"
                       if fullnm == name:
                              sel = i
                              break
       
                       i = i+1
 
                try:
                       url = self.urls[sel]
                       if self.indic == 1:
                               self.session.open(Getvid, name, url)        
                               
                                       

                except:
                       print "This video cannot be played !"
                       return
                




	def callbackView(self, val=0):
		self.index = val
		if self.old_index != self.index:
			self.paintFrame()
	def Exit(self):
		fold = config.plugins.webmedia.cachefold.value
                cmd = "cp " + fold + "/svt/tmp/* " + fold + "/svt/images" + " &"
                os.system(cmd)
                del self.picload
                cmd1 = "rm " + fold + "/svt/tmp/* &"
                os.system(cmd1) 
		self.close(self.index + self.dirlistcount)

#---------------------------------------------------------------------------
class showPic(Screen):


    def __init__(self, session, names, picurls, urls, indic):
		Screen.__init__(self, session)
 
        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"cancel": self.close}, -1)
                self.thumbcount = 0
                self.mediadir = config.plugins.webmedia.cachefold.value + "/webmedia"
                self.names = names
                self.picurls = picurls
                self.urls = urls
                self.indic = indic
                self.thumbnum = len(self.names)
#                os.system("cp /usr/lib/enigma2/python/Plugins/SVTPlayer/default.jpg " + self.mediadir + "/tmp")                
                self.onLayoutFinish.append(self.getthumbs())


    def getthumbs(self):
           self.thumburl = self.picurls[self.thumbcount]
           self.thumbfile1 = self.thumburl
#           self.thumbfile = self.mediadir + "/tmp/" + self.names[self.thumbcount] + ".jpg"
           
           if fileExists(self.thumbfile1):
                   cmd = "cp " + self.thumbfile1 + " " + self.mediadir + "/tmp"
                   os.system(cmd)
                   if self.thumbcount < (self.thumbnum-1):
                            self.thumbcount = self.thumbcount + 1
                            self.getthumbs()
                   else:         
                            self.session.open(Pic_Thumb, self.mediadir, self.names, self.picurls, self.urls, self.indic)
           
           
           else:
#                   downloadPage(self.thumburl, self.thumbfile).addCallback(self.gotThumbnail).addErrback(self.showThumbError)
                   return


    def gotThumbnail(self, txt=""):              
                   if self.thumbcount < (self.thumbnum-1):
                            self.thumbcount = self.thumbcount + 1
                            self.getthumbs()
                   else:         
                            self.session.open(Pic_Thumb, self.mediadir, self.names, self.picurls, self.urls, self.indic)
           
    def showThumbError(self, error):
	           print "thumberror =", error
		   if self.thumbcount < (self.thumbnum-1):
                            cmd1 = "mv " + self.mediadir + "/tmp/default.png " + self.thumbfile 
                           
                            os.system(cmd1)
                            self.thumbcount = self.thumbcount + 1
                            self.getthumbs()
                   else:         
                            self.session.open(Pic_Thumb, self.mediadir, self.names, self.picurls, self.urls, self.indic)

		































































































